#include "observer.h"
#include "Unit1.h"


//---------------------------------------------------------------------------
char* fgets2(FILE* f,char* line)   //Afin d'ignorer les lignes qui commencent par %
{ char* r;
  do   { r=fgets(line,256,f);}  while ((line[0]=='%')&&(r!= NULL));
  return r;
}
//---------------------------------------------------------------------------
observer::observer()
{   Lu1.clear();
    Lu2.clear();
    Ld.clear();
    Lalpha.clear();
    L_is_inlier.clear();
    Xhat=box(4);

    FILE *f;
    char line[256];
    f = fopen("observer.txt","r");
    fgets2(f,line); sscanf(line,"%d",&m);
    fgets2(f,line); sscanf(line,"%d",&q);
    fgets2(f,line); sscanf(line,"%d",&N_Bissect_0);
    fgets2(f,line); sscanf(line,"%d",&N_Bissect_k);
    fgets2(f,line); sscanf(line,"%lf",&ws);
    fgets2(f,line); sscanf(line,"%lf",&coef_friction);
    fgets2(f,line); sscanf(line,"%lf",&coef_puissance_moteur);
    fgets2(f,line); sscanf(line,"%lf",&coef_ecart_moteur);
    fgets2(f,line); sscanf(line,"%lf",&xmin_init);
    fgets2(f,line); sscanf(line,"%lf",&xmax_init);
    fgets2(f,line); sscanf(line,"%lf",&ymin_init);
    fgets2(f,line); sscanf(line,"%lf",&ymax_init);
    fgets2(f,line); sscanf(line,"%lf",&thetamin_init);
    fgets2(f,line); sscanf(line,"%lf",&thetamax_init);
    fgets2(f,line); sscanf(line,"%lf",&vmin_init);
    fgets2(f,line); sscanf(line,"%lf",&vmax_init);
    fgets2(f,line); sscanf(line,"%d",&N_cercles);
    for (int i=0;i<N_cercles;i++)
        {   double x,y,r;
            fgets2(f,line); sscanf(line,"%lf%lf%lf",&x,&y,&r);
            cercles_x.push_back(x); cercles_y.push_back(y); cercles_r.push_back(r);
        }
    while (fgets2(f,line) != NULL)
        {   double xa,ya,xb,yb;
            sscanf(line,"%lf%lf%lf%lf",&xa,&ya,&xb,&yb);
            murs_xa.push_back(xa);  murs_ya.push_back(ya);
            murs_xb.push_back(xb);  murs_yb.push_back(yb);
            N_murs=murs_xa.size();
        }
    fclose(f);

    Xprior=box(4);
    Xprior[1]=interval(xmin_init,xmax_init);   Xprior[2]=interval(ymin_init,ymax_init);  Xprior[3]=interval(thetamin_init,thetamax_init); Xprior[4]=interval(vmin_init,vmax_init);

}
//---------------------------------------------------------------------------
void observer::Init()
{     chenillex.clear();
      chenilley.clear();
      chenilletheta.clear();
      chenillealpha.clear();
      chenilled.clear();
      Xhat=Xprior;
}
//---------------------------------------------------------------------------
void observer::Incremente(interval& X1,interval& Y1, interval& Theta1,interval& V1,
                        interval& X,interval& Y,interval& Theta,interval& V,
                        double u1,double u2)
{        X1    = X     + Form1->dt*Cos(Theta)*V;
         Y1    = Y     + Form1->dt*Sin(Theta)*V;
         Theta1= Theta + Form1->dt*coef_ecart_moteur*(u2-u1);
         V1    = V     + Form1->dt*(coef_puissance_moteur*(u1+u2)-coef_friction*V);
}
//----------------------------------------------------------------------
void observer::Decremente(interval& X1,interval& Y1, interval& Theta1,interval& V1,
                interval& X,interval& Y,interval& Theta,interval& V,
                double u1,double u2)
{        Theta = Theta1-Form1->dt*coef_ecart_moteur*(u2-u1);
         V     = (V1-Form1->dt*coef_puissance_moteur*(u1+u2))/(1-Form1->dt*coef_friction);
         X     = X1-Form1->dt*Cos(Theta)*V;
         Y     = Y1-Form1->dt*Sin(Theta)*V;
}
//----------------------------------------------------------------------
bool observer::Contract(box& P)
{   vector<box> L;
    vector<box> Pi(m);
    bool deb=false;
    Pi[m-1]=P;

    vector<double>   Vu1(m);    list<double>::iterator iLu1=Lu1.begin();       for(int i=0;i<m;i++) {Vu1[i]=*iLu1;       iLu1++;};
    vector<double>   Vu2(m);    list<double>::iterator iLu2=Lu2.begin();       for(int i=0;i<m;i++) {Vu2[i]=*iLu2;       iLu2++;};
    vector<double>   Valpha(m); list<double>::iterator iLalpha=Lalpha.begin(); for(int i=0;i<m;i++) {Valpha[i]=*iLalpha; iLalpha++;}
    vector<interval> Vd(m);     list <interval>::iterator iLd=Ld.begin();      for(int i=0;i<m;i++) {Vd[i]=*iLd;         iLd++;}

    for  (int i=m-2;i>=0;i--)
     	{       Pi[i]=box(4);
                Decremente(Pi[i+1][1],Pi[i+1][2],Pi[i+1][3],Pi[i+1][4],Pi[i][1],Pi[i][2],Pi[i][3],Pi[i][4],Vu1[i],Vu2[i]);
        }   ;

    for  (int i=0;i<m;i++)
        {       interval xi=Pi[i][1];       interval yi=Pi[i][2];
                interval thetai=Pi[i][3];   interval vi=Pi[i][4];
                interval betai=Valpha[i]+thetai;
                interval di=Vd[i];
                CLegOnWallsOrCircles(di,xi,yi,betai,murs_xa,murs_ya,murs_xb,murs_yb,cercles_x,cercles_y,cercles_r);

                Cplus(betai,Valpha[i],thetai,-1);
                interval xip,yip,thetaip,vip;
                for  (int i1=i;i1<m-1;i1++)
                {     Incremente(xip,yip,thetaip,vip,xi,yi,thetai,vi,Vu1[i1],Vu2[i1]);
                      xip=Inter(xip,Pi[i1+1][1]);yip=Inter(yip,Pi[i1+1][2]);
                      thetaip=Inter(thetaip,Pi[i1+1][3]);vip=Inter(vip,Pi[i1+1][4]);
                      xi=xip; yi=yip; thetai=thetaip; vi=vip;
                };
                box Pb(P);
                Pb[1]=xi; Pb[2]=yi; Pb[3]=thetai; Pb[4]=vi;
                L.push_back(Pb);
         }
     vector<box> Lv=L;
     C_q_in(P,m-q,Lv);
}
//----------------------------------------------------------------------
box observer::SIVIA(box& X0, int NbissectMax)
{   int Nbissect=0;
    vector<box> Result;
    list<box> L;
    L.push_back(X0);
    box P;
    Form1->R1.image->Refresh();
    while (!L.empty())
    { P=L.front();
      Form1->R1.DrawCadre(P,clBlue,psSolid,1,2,1);
      L.pop_front();
      bool sortie=false;
      while (!sortie)
       {  box Pold(P);
          Contract(P);
          if (P.IsEmpty())
             sortie=true;
          if (decrease(Pold,P)<0.1) sortie=true;
       }
      if (!P.IsEmpty())
      {  //if ((P.Width()<0.8)) // | (Nbissect>50))
         if (Nbissect>NbissectMax)
            {     Form1->R1.DrawBox(P,clRed,clRed,bsSolid,1,2);
                  Form1->R2.image->Refresh();
                  Result.push_back(P);
            }
         else  {   box P1,P2;
                   Bisect(P,P1,P2);
                   Nbissect++;
                   L.push_back(P1);
                   L.push_back(P2);
               }
      }
    }
    box R=Union(Result);
    Form1->R1.DrawCadre(R,clGreen,psSolid,1,2,1);
    L.clear();
    return R;
} ;
//----------------------------------------------------------------------
void observer::DrawDiagram()
{    Form1->R4.Clean();
     list<interval>::iterator iLd; list<double>::iterator iLalpha;
     iLd=Ld.begin();  iLalpha=Lalpha.begin();
     for  (int i=0;i<m;i++)
         {   Form1->DrawRobot1(Form1->R4,0,0,0, *iLalpha, (*iLd).inf,clGray,2);
             Form1->DrawRobot1(Form1->R4,0,0,0, *iLalpha, (*iLd).sup,clGray,1);
             iLalpha++; iLd++;
         }

     int chenillesize=chenillex.size();
     list<double>::iterator ichenillealpha; list<double>::iterator ichenilled;
     ichenillealpha=chenillealpha.begin();  ichenilled=chenilled.begin();
     for  (int i=0;i<chenillesize;i++)
         {   Form1->DrawRobot1(Form1->R4,0,0,0, *ichenillealpha, *ichenilled,clBlack,2);
             ichenillealpha++; ichenilled++;
         }
     Form1->R4.image->Refresh();
}
//----------------------------------------------------------------------
void observer::Draw_inliers()
{    list<int>::iterator i_L_is_inlier;
     int nb_inliers=0;
     i_L_is_inlier=L_is_inlier.begin();
     for  (int i=0;i<L_is_inlier.size();i++)
         {   nb_inliers=nb_inliers+* i_L_is_inlier;
             i_L_is_inlier++;
         }
      Form1->DrawDataPoint(Form1->Rcourbes,nb_inliers,clBlack,1);
      Form1->DrawDataPoint(Form1->Rcourbes,m-q,clGray,1);
      //Form1->DrawDataPoint(Form1->Rcourbes,L_is_inlier.size(),clPurple,1);
      //Form1->DrawDataPoint(Form1->Rcourbes,bk*100,clBlack,1);
      Form1->Rcourbes.image->Refresh();

      Form1->Memo1->Text="t = "+String(Form1->t)+" \r\n ";
      Form1->Memo1->Text=Form1->Memo1->Text+"m = "+String(m)+" \r\n ";
      Form1->Memo1->Text=Form1->Memo1->Text+"q = "+String(q)+" \r\n ";
      Form1->Memo1->Text=Form1->Memo1->Text+"Number of outliers = "+String(m-nb_inliers)+" \r\n ";
      Form1->Memo1->Text=Form1->Memo1->Text+"alpha_bk = "+String(alpha_bk)+" \r\n ";
      Form1->Memo1->Text=Form1->Memo1->Text+"bk = "+String(bk)+" \r\n ";
      Form1->Memo1->Refresh();


}

//----------------------------------------------------------------------
void observer::DrawChenille(double xhat,double yhat, double thetahat, double alpha)
{    Form1->R3.Clean();
     Form1->DrawRoom(Form1->R3);
     if (chenillex.size()>m)
     { chenillex.pop_front(); chenilley.pop_front(); chenilletheta.pop_front(); chenillealpha.pop_front(); chenilled.pop_front();  }
     double d1a=DistanceDirSegments(xhat,yhat,alpha+thetahat,murs_xa,murs_ya,murs_xb,murs_yb);
     double d1b=DistanceDirCercles(xhat,yhat,alpha+thetahat,cercles_x,cercles_y,cercles_r);
     double d1=min(d1a,d1b);
     chenillex.push_back(xhat); chenilley.push_back(yhat); chenilletheta.push_back(thetahat); chenillealpha.push_back(alpha);     chenilled.push_back(d1);

     //Form1->DrawDataCadre(Form1->Rd,d1,clGray,1);


     int chenillesize=chenillex.size();
     list<double>::iterator ichenillex; list<double>::iterator ichenilley; list<double>::iterator ichenilletheta; list<double>::iterator ichenillealpha; list<double>::iterator ichenilled;
     ichenillex=chenillex.begin();      ichenilley=chenilley.begin();      ichenilletheta=chenilletheta.begin();  ichenillealpha=chenillealpha.begin();  ichenilled=chenilled.begin();
     for  (int i=0;i<chenillesize;i++)
         {   Form1->DrawRobot1(Form1->R3,*ichenillex,*ichenilley,*ichenilletheta, *ichenillealpha, *ichenilled,clGray,1);
             ichenillex++; ichenilley++; ichenilletheta++; ichenillealpha++; ichenilled++;
         }
     Form1->R3.image->Refresh();
}
//---------------------------------------------------------------------------
void observer::clock(double u1,double u2,interval d,double alpha,int is_inlier, interval boussole,int NbissectMax)
{     //  (au cas ou une boussole est accessible)
//     interval sinTheta=Inter(Sin(Xhat[3]),Sin(boussole));    Csin(sinTheta,Xhat[3],-1);   interval cosTheta=Inter(Cos(Xhat[3]),Cos(boussole));      Ccos(cosTheta,Xhat[3],-1);
     Lu1.push_back(u1); Lu2.push_back(u2);  Ld.push_back(d);  Lalpha.push_back(alpha); L_is_inlier.push_back(is_inlier);
     if (Lu1.size()>m)
     { Lu1.pop_front(); Lu2.pop_front(); Ld.pop_front(); Lalpha.pop_front(); L_is_inlier.pop_front(); }
     Draw_inliers();
     if (Lu1.size()!=m) return;  //not enough measurements

     interval sinTheta=Inter(Sin(Xhat[3]),Sin(boussole));    Csin(sinTheta,Xhat[3],-1);   interval cosTheta=Inter(Cos(Xhat[3]),Cos(boussole));      Ccos(cosTheta,Xhat[3],-1);

     Xhat=SIVIA(Xhat,NbissectMax);
     DrawDiagram();
     Form1->DrawRoom(Form1->Rxy);
     if (Xhat.IsEmpty())  // An insconsistency is detected. The observer is not reliable anymore.
         { //Init();
           Form1->R1.DrawBox(Xprior,clPurple,clPurple,bsSolid,1,2);
           return;
         }
     DrawChenille(Center(Xhat[1]),Center(Xhat[2]),Center(Xhat[3]),alpha);
     Form1->Rxy.DrawPointCadre(Center(Xhat[1]),Center(Xhat[2]),clGray,0.05,0.05);
     Form1->DrawDataBar(Form1->Rx,Xhat[1],clGray);
     Form1->DrawDataBar(Form1->Ry,Xhat[2],clGray);
     Form1->DrawDataBar(Form1->Rtheta,Xhat[3],clGray);
     Form1->DrawDataBar(Form1->Rv,Xhat[4],clGray);

     box Xhatp(4);
     Incremente(Xhatp[1],Xhatp[2],Xhatp[3],Xhatp[4],Xhat[1],Xhat[2],Xhat[3],Xhat[4],u1,u2);
     box StateNoise(4);
     interval Noise=interval(-0.0001,0.0001);
     StateNoise[1]=Form1->dt*Noise; StateNoise[2]=Form1->dt*Noise; StateNoise[3]=Form1->dt*Noise; StateNoise[4]=Form1->dt*Noise;
     Xhatp=Xhatp+StateNoise;
     Xhatp[1]=Inter(Xhatp[1],Xprior[1]);
     Xhatp[2]=Inter(Xhatp[2],Xprior[2]);  //pas le 3ime  cause du 2.pi
     Xhatp[4]=Inter(Xhatp[4],interval(0,1.8));
     Xhat=Xhatp;
     return;
}
//---------------------------------------------------------------------------
void observer::clock_init(double u1,double u2,interval d,double alpha,int is_inlier, interval boussole)  //On prend son temps
{
   clock(u1,u2,d,alpha,is_inlier,boussole,N_Bissect_0);

    double beta1=beta(m,Form1->prob_inlier, m-q);
    double num=(1-Form1->prob_inlier)*(m-q)*beta1;
    double den=m*(1-gamma(m,Form1->prob_inlier,q));
    alpha_bk=1-num/den;
    alpha_bk=0.99986;
    // nouvelle version
    double aux=log(1-gamma(m,Form1->prob_inlier,q))/m;
    alpha_bk=exp(aux);
    bk=1-gamma(m,Form1->prob_inlier,q);

}
//---------------------------------------------------------------------------
void observer::clock_k(double u1,double u2,interval d,double alpha,int is_inlier, interval boussole)   //temps rel
{
   bk=bk*alpha_bk;
   clock(u1,u2,d,alpha,is_inlier,boussole,N_Bissect_k);
}
//---------------------------------------------------------------------------



