#ifndef OBSERVERH
#define OBSERVERH
#include <math.h>
#include <list.h>
#include <vector.h>
#include "box.h"
#include "interval.h"
#define PI 3.1415926535897932384626433832795f
#define RadToDeg 180.0f/PI
#define PI_sur_180 PI/180.0f
//---------------------------------------------------------------------------
class observer
{
public:
        observer();
        void DrawDiagram();
        void Init();
        bool Contract(box&);
        void DrawChenille(double xhat,double yhat, double thetahat, double alpha);
        void Draw_inliers();
        box SIVIA(box& X0,int);


        void clock(double u1,double u2,interval d,double alpha,int is_inlier, interval boussole,int);
        void clock_init(double u1,double u2,interval d,double alpha,int is_inlier, interval boussole);
        void clock_k(double u1,double u2,interval d,double alpha,int is_inlier, interval boussole);



        void Incremente(interval& X1,interval& Y1, interval& Theta1,interval& V1,
                        interval& X,interval& Y,interval& Theta,interval& V,double u1,double u2);
        void Decremente(interval&,interval&,interval&,interval&,
                interval& X,interval& Y,interval& Theta,interval& V,double u1,double u2);
        int m;
        int q;
        int N_Bissect_0;
        int N_Bissect_k;
        double ws;
        double coef_friction;
        double coef_puissance_moteur;
        double coef_ecart_moteur;
        double xmin_init,xmax_init,ymin_init,ymax_init,thetamin_init,thetamax_init,vmin_init,vmax_init;
        int N_murs;
        vector <double> murs_xa,murs_xb,murs_ya,murs_yb;
        int N_cercles;
        vector <double> cercles_x,cercles_y,cercles_r;

        box Xprior;

        list<double> Lu1;
        list<double> Lu2;
        list<double> Lalpha;
        list<interval> Ld;
        list<int> L_is_inlier;
        list<double> chenillex;
        list<double> chenilley;
        list<double> chenilletheta;
        list<double> chenillealpha;
        list<double> chenilled;
        box Xhat;
        double alpha_bk,bk;
};
//---------------------------------------------------------------------------
#endif OBSH

